                  PROGRAM

                  MAP
primeautoinc procedure
primeautoinco procedure
                  END

ora_owner   string(80)
ora_file     string(80)
ora_pass    string(10)
ef_name     string(20)

autotest             FILE,DRIVER('TOPSPEED'),PRE(AUT),CREATE,BINDABLE,THREAD
Keyid                    KEY(AUT:id),NOCASE,OPT
Record                   RECORD,PRE()
id                          LONG
addtime                     TIME
threadref                   STRING(2)
                         END
                     END                 
                     
errorfile             FILE,DRIVER('ASCII'),PRE(EF),CREATE,BINDABLE,THREAD,name(ef_name)
Record                   RECORD,PRE()
line            string(120)
                         END
                     END                       
                     
AUTOORA              FILE,DRIVER('ORACLE'),OWNER(ora_owner),NAME(ora_file),PRE(AUT1),BINDABLE,THREAD
pk_autoora          key(aut1:id),nocase
Record                   RECORD,PRE()
ID                          LONG,NAME('"ID"')
ADDTIME                     STRING(8),NAME('"ADDTIME"')
ADDTIME_GROUP               GROUP,OVER(ADDTIME)
ADDTIME_DATE                  DATE
ADDTIME_TIME                  TIME
                            END
THREADREF                   STRING(2),NAME('"THREADREF"')
                         END
                     END                       


i                    SHORT
numloops short
tag      short
addtype string(1)
at_sign short
error_count short
attempts short
  CODE
 addtype=command('1')
 !addtypes are:
 ! A=Clarion file: Clarion autoinc
 ! B=Clarion file: straight add
 ! C=Oracle table: Clarion autoinc
 ! D=oracle table: Oracle sequence
 numloops=command('2')
 tag=command('3')
 ora_owner=command('4')
 ora_file=command('5')
 ora_pass=command('6')
 if ora_owner <> ''
   at_sign = instring('@',ora_owner)
   if at_sign > 0
      ora_owner=ora_owner[1:at_sign-1] & '/' & clip(ora_pass) & ora_owner[at_sign : 80]
   end
 end
 ef_name = 'ef' & tag & '.txt'
 !message('ora owner is ' & ora_owner)
 remove(errorfile)
 open(errorfile)
 if errorcode() = 2
    create(errorfile)
    open(errorfile)
 else
    message('error opening errorfile ' & error())
 end    
 case addtype
 of 'A'
 orof 'B'
   share(autotest)
   if errorcode() = 2
     create(autotest)
     share(autotest,2)
     !message('autotest created')
   end
 else
   share(autoora)  !No create "allowed"
   if error() then
     message('error opening autoora ' & error() & ' ' & ora_owner & ':' & ora_file)
   end
 end
 ! message('called to do ' & numloops & ' loops with tag ' & tag)
 loop i=1 to numloops
  case addtype
  of 'A'
  orof 'B'
    if addtype = 'A' then  PrimeAutoinc().
    logout(2,autotest)
    aut:addtime = clock()
    AUT:threadref=tag
    add(autotest)
  else
    attempts=0
    logout(2,autoora)
    loop
      if addtype = 'C' then  PrimeAutoinco().
      aut1:addtime_date=today()
      aut1:addtime_time=clock()
      AUT1:threadref=tag
      add(autoora)
      IF ERRORCODE()
        Attempts += 1
        IF Attempts = 6
           !changed from the normal value of 3 in the shipping templates
           !this _is_ a heavy traffic situation
           ef:line = tag & ':' & i & ' ' & error()
           error_count += 1
           add(errorfile)
        END
      else
        break ! out of loop: should normally only do once
      end
    end !loop
  end
  commit
  YIELD
 end !loop
 case addtype
 of 'A'
 orof 'B'
   close(autotest)
 else
   close(autoora)
 end
 close(errorfile)
 if error_count = 0 then remove(errorfile).


PrimeAutoInc PROCEDURE
  CODE
      SET(aut:KeyID)
      PREVIOUS(autotest)
      CASE ERRORCODE()
      OF 0
        aut:id= aut:id + 1
      OF 35
        Aut:id = 1
      END
      if aut:id = 0 then aut:id = 1.

PrimeAutoInco PROCEDURE
  CODE
      SET(aut1:pk_autoora)
      previous(autoora)
      CASE ERRORCODE()
      OF 0
        aut1:id= aut1:id + 1
      OF 35
        Aut1:id = 1
      END
      if aut1:id = 0 then aut1:id = 1.
